-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 5 of the Cloudera Navigator schema. Adds the hive audit table to navigator schema.
--

UPDATE GOV_SCHEMA_VERSION SET VERSION = 5;

create sequence HIVE_AUDIT_EVENTS_SEQUENCE;

create table HIVE_AUDIT_EVENTS (
  ID                       bigint not null default nextval('HIVE_AUDIT_EVENTS_SEQUENCE'),
  EVENT_TIME               bigint not null,
  ALLOWED                  integer not null,
  SERVICE_NAME             varchar(255) not null,
  USERNAME                 varchar(255) not null,
  IP_ADDR                  varchar(255) not null,
  OPERATION                varchar(255) not null,
  DATABASE_NAME            varchar(1024) not null,
  OBJECT_TYPE              varchar(255) not null,
  TABLE_NAME               varchar(1024),
  OPERATION_TEXT           varchar(1024),
  primary key (ID)
);

create index IDX_HIVE_EVENT_TIME on HIVE_AUDIT_EVENTS (EVENT_TIME);
